# This is a sample build configuration for Java (Gradle).
# Check our guides at https://confluence.atlassian.com/x/zd-5Mw for more examples.
# Only use spaces to indent your .yml configuration.
# -----
# You can specify a custom docker image from Docker Hub as your build environment.
image: java:8

pipelines:
  default:
    - step:
        name: Build and Share Apk
        script:
          - echo "Build and Share Apk pipeline"
    - step:
        trigger: manual
        caches:
          - android-sdk
          - gradle
        script:
           # Download and unzip android sdk
          - wget --quiet --output-document=android-sdk.zip https://dl.google.com/android/repository/sdk-tools-linux-3859397.zip
          - unzip -o -qq android-sdk.zip -d android-sdk

          # Define Android Home and add PATHs
          - export ANDROID_HOME="/opt/atlassian/pipelines/agent/build/android-sdk"
          - export PATH="$ANDROID_HOME/tools:$ANDROID_HOME/tools/bin:$ANDROID_HOME/platform-tools:$PATH"

          # Download packages.
          - yes | sdkmanager "platform-tools"
          - yes | sdkmanager "platforms;android-27"
          - yes | sdkmanager "build-tools;27.0.3"
          - yes | sdkmanager "extras;android;m2repository"
          - yes | sdkmanager "extras;google;m2repository"
          - yes | sdkmanager "extras;google;instantapps"
          - yes | sdkmanager --licenses

          # Build apk2
          - chmod a+x ./gradlew
          - ./gradlew assembleDebug
          - apt-get install -y curl
          - cd app/build/outputs/apk/debug
          - pwd
          - ls -al
          - apk_name="app_$(date +%d-%m-%Y-%H_%M).apk"
         # - mv app-debug.apk $apk_name
          - curl https://slack.com/api/files.upload -F token="${SLACK_TOKEN}" -F channels="${SLACK_CHANNEL}" -F title="${UPLOAD_MESSAGE_TITLE}" -F filename="$apk_name" -F file=@"app-debug.apk"

definitions:
    caches:
      android-sdk: android-sdk
